#! /usr/bin/env python
import socket
import subprocess
from xml.etree import ElementTree

EXECUTOR_ADDR = '239.192.3.2'
EXECUTOR_PORT = 53001

# If BROKEN_OBS2SCRIPT is set to True, obs2script is not inserting the
# "intent" elements with the scan numbers, so we just have to make
# them up (using a counter)
BROKEN_OBS2SCRIPT = True
scan_counter = 0

if __name__ == '__main__':
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    s.bind(('', EXECUTOR_PORT))
    s.setsockopt(socket.SOL_IP, socket.IP_ADD_MEMBERSHIP,
                 socket.inet_aton(EXECUTOR_ADDR) + socket.inet_aton('0.0.0.0'))
    while True:
        msg = s.recv(4096)
        try:
            doc = ElementTree.fromstring(msg)
            if doc.tag == 'Observation' \
               and doc.find('correlator').text.strip() == 'widar':
                name = doc.find('name')
                if name is not None and name.text.strip() == 'FINISH':
                    stop_cmd = 'stop_subscan -s %(subarrayId)s %(startTime)s' \
                               % doc.attrib
                    print 'command:', stop_cmd # TODO: remove
                    subprocess.call(stop_cmd.split())
                    scan_counter = 0
                else:
                    if not BROKEN_OBS2SCRIPT:
                        scannum_intent = \
                            [i.text.split('=')[1].strip()
                             for i in doc.findall('intent')
                             if i.text.startswith('ScanNumber')]
                        doc.attrib['scanNumber'] = int(scannum_intent[0])
                    else:
                        scan_counter += 1
                        doc.attrib['scanNumber'] = scan_counter
                    start_cmd = 'start_subscan -s %(subarrayId)s ' \
                                '%(startTime)s %(scanNumber)d' % doc.attrib
                    print 'command:', start_cmd # TODO: remove
                    subprocess.call(start_cmd.split())
        except:
            pass
