#! /bin/bash
#
# mount_pipelinefs
#
# Run pipelinefs as WCBE_USER and mount file system at
# WCBE_PIPELINEFS.
#
if [ -f /etc/sysconfig/wcbe.conf ]; then
    . /etc/sysconfig/wcbe.conf
fi
if [ -f $WCBE_PATH/share/wcbe_common.sh ]; then
    . $WCBE_PATH/share/wcbe_common.sh
elif [ -f $DEFAULT_WCBE_PATH/share/wcbe_common.sh ]; then
    . $DEFAULT_WCBE_PATH/share/wcbe_common.sh
fi
set_environment

mkdir $WCBE_PIPELINEFS 2> /dev/null
chgrp $WCBE_GROUP $WCBE_PIPELINEFS
if [ $? -ne 0 ]; then
    echo "Failed to set group for directory $WCBE_PIPELINEFS...exiting"
    exit -1
fi
chmod 775 $WCBE_PIPELINEFS
if [ $? -ne 0 ]; then
    echo "Failed to set mode for directory $WCBE_PIPELINEFS...exiting"
    exit -1
fi
ssh $WCBE_USER@$( hostname ) pipelinefs $WCBE_PIPELINEFS
