# -*- sh -*-

# This is ugly, but I'm no bash expert, and passing arrays to/from
# bash functions is something I don't want to figure out at this time.
declare -a LFXSET

function set_environment {
    if test -z "$WCBE_PATH" ; then
        WCBE_PATH=$DEFAULT_WCBE_PATH
    fi
    if test -z "$WCBE_PIPELINEFS" ; then
        WCBE_PIPELINEFS=$DEFAULT_WCBE_PIPELINEFS
    fi
    if test -z "$WCBE_BDFDIR" ; then
        WCBE_BDFDIR=$DEFAULT_WCBE_BDFDIR
    fi
    if test -z "$WCBE_USER" ; then
        WCBE_USER=$DEFAULT_WCBE_USER
    fi
    if test -z "$WCBE_GROUP" ; then
        WCBE_GROUP=$DEFAULT_WCBE_GROUP
    fi
    if test -z "$WCBE_CONFIG_FIFO" ; then
        WCBE_CONFIG_FIFO=$DEFAULT_WCBE_CONFIG_FIFO
    fi
    if test -z "$WCBE_LAG_FRAME_INPUT_PORT" ; then
        WCBE_LAG_FRAME_INPUT_PORT=$DEFAULT_WCBE_LAG_FRAME_INPUT_PORT
    fi
    if test -z "$WCBE_MC_PORT" ; then
        WCBE_MC_PORT=$DEFAULT_WCBE_MC_PORT
    fi
    if test -z "$WCBE_NODE_PREFIX" ; then
        WCBE_NODE_PREFIX=$DEFAULT_WCBE_NODE_PREFIX
    fi
    if test -z "$WCBE_MAX_LAG_FRAME_INTERFACES" ; then
        WCBE_MAX_LAG_FRAME_INTERFACES=$DEFAULT_WCBE_MAX_LAG_FRAME_INTERFACES
    fi
    if test -z "$WCBE_NODE_ID_PARTS" ; then
        WCBE_NODE_ID_PARTS=$DEFAULT_WCBE_NODE_ID_PARTS
    fi
    if test -z "$WCBE_LFX_FILE" ; then
        WCBE_LFX_FILE=$DEFAULT_WCBE_LFX_FILE
    fi

    exec 5<$WCBE_LFX_FILE
    let count=0
    while read LINE <&5 ; do
        NODE=${LINE#$WCBE_NODE_PREFIX}
        if [ "$NODE" != "$LINE" ] ; then
            LFXSET[$count]=$NODE-*
            ((count++))
        fi
    done
    exec 5>&-

    declare -a INSTANCES
}

function check_pipelinefs {
    if test -z "$WCBE_PIPELINEFS" ; then
        return 1
    fi
    FS=$( grep $WCBE_PIPELINEFS /proc/mounts | cut -d' ' -f 1)
    if test "x$FS" == xpipelinefs -o "x$FS" == xfuse ; then
        return 0
    fi
    return 1
}

function check_bdfdir {
    if test -z "$WCBE_BDFDIR" ; then
        return 1;
    fi
    if [ -d $WCBE_BDFDIR/.private ]; then
        return 0
    fi
    return 1
}

function parse_start {
    # first check for relative time ("\+\d+")
    if [ "x$1" != "x${1#+}" ]; then
        declare -i T="${1#+}"
        if [ "x$T" == "x${1#+}" ]; then
            START=$(( $(date +%s) + $T ))
            return 0
        fi
    # otherwise, we assume a time in MJD (fractional days)
    else
        START=$( echo "$1 40587 - 86400 * 0.5 + n" | dc )
        START=${START%%.[0-9]*}
        return 0
    fi
    return 1
}

function pipelinefs_glob {
    DIRS=$( for d in $( ls -d $WCBE_PIPELINEFS/$1 ); do basename $d; done )
    REGEXP=""
    for lfx in "${LFXSET[@]}" ; do
        if test -z "$REGEXP" ; then
            REGEXP=$lfx
        else
            REGEXP="$REGEXP\\|$lfx"
        fi
    done
    if test -n "$REGEXP" ; then
        for i in $( echo "$DIRS" | grep "$REGEXP" ); do
            INSTANCES[${#INSTANCES[*]}]=$i
        done
    fi
}
