#ifndef WE_BDF_H_
#define WE_BDF_H_

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <glib.h>
#include <stdio.h>

#include <cobdf.h>
#include <sdmhdr.h>
#include <tree.h>

G_BEGIN_DECLS

typedef struct we_bdf_t {
    FILE *file;
    off_t origin_offset;
    GHashTable *index;
    sdmhdr_main_hdr_t *main_hdr;
    off_t highest_read_offset;
    GStaticRecMutex index_mutex;
    gchar *main_boundary;
} we_bdf_t;

extern we_bdf_t *we_bdf_new(FILE *file, const sdmhdr_main_hdr_t *header);
extern we_bdf_t *we_bdf_read(FILE *file);
extern gchar **we_bdf_project_paths(we_bdf_t *we_bdf);
extern sdmhdr_main_hdr_t *we_bdf_main_hdr(we_bdf_t *we_bdf);
extern sdmhdr_subset_hdr_t *we_bdf_subset_hdr(we_bdf_t *we_bdf,
                                              const gchar *project_path);
extern tree_t *we_bdf_bincomp(we_bdf_t *we_bdf, const gchar *project_path,
                              CobdfBincomp bincomp);
extern off_t we_bdf_add_subset(we_bdf_t *we_bdf,
                               const sdmhdr_subset_hdr_t *header);
extern void we_bdf_add_subset_seq(
    we_bdf_t *we_bdf, const sdmhdr_subset_hdr_t *subset_template,
    guint last_index);
/* extern void we_bdf_truncate(we_bdf_t *we_bdf, guint num_subsets); */
extern void we_bdf_close(we_bdf_t *we_bdf);
extern void we_bdf_free(we_bdf_t *we_bdf);

G_END_DECLS

#endif /* WE_BDF_H_ */
