#ifndef WCBE_ACCUMULATE_H_
#define WCBE_ACCUMULATE_H_

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <gst/gst.h>
#include <glib.h>

G_BEGIN_DECLS

#define WCBE_TYPE_ACCUMULATE \
    (wcbe_accumulate_get_type())
#define WCBE_ACCUMULATE(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_ACCUMULATE, WcbeAccumulate))
#define WCBE_ACCUMULATE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_ACCUMULATE, WcbeAccumulate))
#define WCBE_ACCUMULATE_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), WCBE_TYPE_ACCUMULATE, WcbeAccumulateClass))
#define WCBE_IS_ACCUMULATE(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_ACCUMULATE))
#define WCBE_IS_ACCUMULATE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_ACCUMULATE))

typedef struct _WcbeAccumulate WcbeAccumulate;
typedef struct _WcbeAccumulateClass WcbeAccumulateClass;

struct _WcbeAccumulate {
    GstElement element;
    GHashTable *products;
    GPtrArray *src_pads;
    GPtrArray *sink_pads;
    GStaticMutex mtx;
    guint64 interval; // ns
    guint64 t0;       // ns
    guint num_in;
    guint num_out;
    GThread *sweeper;
};

struct _WcbeAccumulateClass {
    GstElementClass parent_class;
};

extern GType wcbe_accumulate_get_type(void);

G_END_DECLS

#endif /* WCBE_ACCUMULATE_H_ */
