#ifndef WCBE_BDF_VISDATA_H__
#define WCBE_BDF_VISDATA_H__

#include <gst/gst.h>
#include <gst/base/gstbasesink.h>
#include <wcbe_config.h>
#include <we_bdf.h>
#include <unistd.h>
#include <fcntl.h>

G_BEGIN_DECLS

#define WCBE_TYPE_BDF_VISDATA \
  (wcbe_bdf_visdata_get_type())
#define WCBE_BDF_VISDATA(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_BDF_VISDATA,WcbeBdfVisdata))
#define WCBE_BDF_VISDATA_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_BDF_VISDATA,WcbeBdfVisdataClass))
#define WCBE_BDF_VISDATA_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS((obj),WCBE_TYPE_BDF_VISDATA,WcbeBdfVisdataClass))
#define WCBE_IS_BDF_VISDATA(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_BDF_VISDATA))
#define WCBE_IS_BDF_VISDATA_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_BDF_VISDATA))

typedef struct _WcbeBdfVisdata      WcbeBdfVisdata;
typedef struct _WcbeBdfVisdataClass WcbeBdfVisdataClass;

struct _WcbeBdfVisdata {
    GstBaseSink basesink;
    const wcbe_config_t *config;
    GList *subscans;
    GHashTable *product_maps;
    GStaticRecMutex mtx;
    gchar *pipeline_name;
    gchar *wcbe_name;
    guint64 integration_period;
    guint num_written;
    guint num_dropped;
};

typedef struct _wcbe_bdf_t wcbe_bdf_t;

struct _WcbeBdfVisdataClass {
    GstBaseSinkClass parent_class;
    GStaticMutex mtx;
    GHashTable *bdfs;
    gchar *bdfdir;
    void (*set_bdfdir)(WcbeBdfVisdata *vis, const gchar *bdfdir);
    wcbe_bdf_t *(*ref_bdf)(WcbeBdfVisdata *vis, const gchar *uid);
    void (*unref_bdf)(WcbeBdfVisdata *vis, const gchar *uid);
    gboolean (*lock_bdf_tail)(WcbeBdfVisdata *vis, const gchar *uid);
    void (*unlock_bdf_tail)(WcbeBdfVisdata *vis, const gchar *uid);
    wcbe_bdf_t *(*open_bdf)(WcbeBdfVisdata *vis, const gchar *uid);
};

extern GType wcbe_bdf_visdata_get_type(void);

G_END_DECLS

#endif /* WCBE_BDF_VISDATA_H__ */
