#ifndef WCBE_FDVC_NORMALIZE_H_
#define WCBE_FDVC_NORMALIZE_H_

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <gst/gst.h>
#include <gst/base/gstcollectpads.h>
#include <wcbe_enums.h>

G_BEGIN_DECLS

#define WCBE_TYPE_FDVC_NORMALIZE \
    (wcbe_fdvc_normalize_get_type())
#define WCBE_FDVC_NORMALIZE(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_FDVC_NORMALIZE, WcbeFdvcNormalize))
#define WCBE_FDVC_NORMALIZE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_FDVC_NORMALIZE, WcbeFdvcNormalize))
#define WCBE_FDVC_NORMALIZE_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), WCBE_TYPE_FDVC_NORMALIZE, WcbeFdvcNormalizeClass))
#define WCBE_IS_FDVC_NORMALIZE(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_FDVC_NORMALIZE))
#define WCBE_IS_FDVC_NORMALIZE_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_FDVC_NORMALIZE))

typedef struct _WcbeFdvcNormalize WcbeFdvcNormalize;
typedef struct _WcbeFdvcNormalizeClass WcbeFdvcNormalizeClass;

#define WCBE_FDVC_NORMALIZE_LAGS_PAD_INDEX 0
#define WCBE_FDVC_NORMALIZE_WEIGHTS_PAD_INDEX 1
#define WCBE_FDVC_NORMALIZE_NUM_PADS 2

struct _WcbeFdvcNormalize {
    GstElement element;
    // the first dimension of srcpads indexes partial correlation
    // products, the second, media types
    GstPad *sinkpads[4][WCBE_FDVC_NORMALIZE_NUM_PADS];
    GstPad *srcpads[4][WCBE_FDVC_NORMALIZE_NUM_PADS];
    WcbeCorrBits nbits;
    GstBuffer *lags[4];
    GstBuffer *dvs[4];
    gboolean is_normalized[4];
    gboolean null_quotients;
    gint last_partprod;
    guint num_normalized;
    guint num_dropped;
};

struct _WcbeFdvcNormalizeClass {
    GstElementClass parent_class;
};

extern GType wcbe_fdvc_normalize_get_type(void);

G_END_DECLS
#endif /* WCBE_FDVC_NORMALIZE_H_ */
