#ifndef WCBE_LAGSET_DEMUX_H_
#define WCBE_LAGSET_DEMUX_H_

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <gst/gst.h>
#include <glib.h>
#include <wcbe_enums.h>

G_BEGIN_DECLS

#define WCBE_TYPE_LAGSET_DEMUX \
    (wcbe_lagset_demux_get_type())
#define WCBE_LAGSET_DEMUX(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LAGSET_DEMUX, WcbeLagsetDemux))
#define WCBE_LAGSET_DEMUX_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LAGSET_DEMUX, WcbeLagsetDemux))
#define WCBE_LAGSET_DEMUX_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), WCBE_TYPE_LAGSET_DEMUX, WcbeLagsetDemuxClass))
#define WCBE_IS_LAGSET_DEMUX(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LAGSET_DEMUX))
#define WCBE_IS_LAGSET_DEMUX_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LAGSET_DEMUX))

typedef struct _WcbeLagsetDemux WcbeLagsetDemux;
typedef struct _WcbeLagsetDemuxClass WcbeLagsetDemuxClass;

#define WCBE_LAGSET_DEMUX_LAGS_PAD_INDEX 0
#define WCBE_LAGSET_DEMUX_TIMESTAMP_PAD_INDEX 1
#define WCBE_LAGSET_DEMUX_DATAVALID_PAD_INDEX 2
#define WCBE_LAGSET_DEMUX_NUM_SRC_PADS 3

struct _WcbeLagsetDemux {
    GstElement element;
    GstPad *sinkpad;
    WcbeCorrBits nbits;
    // the first dimension of data_srcpads indexes partial correlation
    // products, the second, media types
    GstPad *srcpads[4][WCBE_LAGSET_DEMUX_NUM_SRC_PADS];
    GHashTable *prodcaps;
};

struct _WcbeLagsetDemuxClass {
    GstElementClass parent_class;
};

extern GType wcbe_lagset_demux_get_type(void);

G_END_DECLS

#endif /* WCBE_LAGSET_DEMUX_H_ */
