#ifndef WCBE_LAGSET_DUMP_H_
#define WCBE_LAGSET_DUMP_H_

#include <gst/gst.h>
#include <gst/base/gstbasetransform.h>
#include <wcbe_config.h>

G_BEGIN_DECLS

#define WCBE_TYPE_LAGSET_DUMP (wcbe_lagset_dump_get_type())
#define WCBE_LAGSET_DUMP(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LAGSET_DUMP,WcbeLagsetDump))
#define WCBE_LAGSET_DUMP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LAGSET_DUMP,WcbeLagsetDumpClass))
#define WCBE_IS_LAGSET_DUMP(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LAGSET_DUMP))
#define WCBE_IS_LAGSET_DUMP_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LAGSET_DUMP))

typedef struct _WcbeLagsetDump      WcbeLagsetDump;
typedef struct _WcbeLagsetDumpClass WcbeLagsetDumpClass;

struct _WcbeLagsetDump {
    GstBaseTransform element;
    gboolean do_output;
    off64_t max_file_size;
    GRegex *product_regex;
    GStaticMutex mutex;
    GHashTable *output_products;
    GPtrArray *configs;
    gchar *output_dir;
};

struct _WcbeLagsetDumpClass {
  GstBaseTransformClass parent_class;
};

extern GType wcbe_lagset_dump_get_type(void);

G_END_DECLS

#endif /* WCBE_LAGSET_DUMP_H_ */
