#ifndef WCBE_LAGSET_SINK_H__
#define WCBE_LAGSET_SINK_H__

#include <gst/gst.h>
#include <gst/base/gstbasesink.h>
#include <wcbe_config.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_LAGSET_SINK \
  (wcbe_lagset_sink_get_type())
#define WCBE_LAGSET_SINK(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LAGSET_SINK,WcbeLagsetSink))
#define WCBE_LAGSET_SINK_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LAGSET_SINK,WcbeLagsetSinkClass))
#define WCBE_IS_LAGSET_SINK(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LAGSET_SINK))
#define WCBE_IS_LAGSET_SINK_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LAGSET_SINK))

typedef struct _WcbeLagsetSink      WcbeLagsetSink;
typedef struct _WcbeLagsetSinkClass WcbeLagsetSinkClass;

struct _WcbeLagsetSink {
    GstBaseSink basesink;
    gchar *sockdir;
    gint sockfd;
    GHashTable *configs;
    GStaticMutex configs_mutex;
    guint64 num_orphaned_lagsets;
};

struct _WcbeLagsetSinkClass {
    GstBaseSinkClass parent_class;
    GQuark cfg_data;
};

extern GType wcbe_lagset_sink_get_type(void);

G_END_DECLS

#endif /* WCBE_LAGSET_SINK_H__ */
