#ifndef WCBE_LC7_H_
#define WCBE_LC7_H_

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <gst/gst.h>
#include <gst/base/gstcollectpads.h>
#include <wcbe_enums.h>

G_BEGIN_DECLS

#define WCBE_TYPE_LC7 \
    (wcbe_lc7_get_type())
#define WCBE_LC7(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LC7, WcbeLc7))
#define WCBE_LC7_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LC7, WcbeLc7))
#define WCBE_LC7_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), WCBE_TYPE_LC7, WcbeLc7Class))
#define WCBE_IS_LC7(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LC7))
#define WCBE_IS_LC7_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LC7))

typedef struct _WcbeLc7 WcbeLc7;
typedef struct _WcbeLc7Class WcbeLc7Class;

#define WCBE_LC7_LAGS_PAD_INDEX 0
#define WCBE_LC7_WEIGHTS_PAD_INDEX 1
#define WCBE_LC7_NUM_PADS 2

struct _WcbeLc7 {
    GstElement element;
    // the first dimension of srcpads indexes partial correlation
    // products, the second, media types
    GstPad *sinkpads[4][WCBE_LC7_NUM_PADS];
    GstPad *srcpad;
    GstBuffer *lags[4];
    GstBuffer *wgts[4];
    gint last_partprod;
    guint num_dropped;
    guint num_sent;
};

struct _WcbeLc7Class {
    GstElementClass parent_class;
};

extern GType wcbe_lc7_get_type(void);

G_END_DECLS
#endif /* WCBE_LC7_H_ */
