#ifndef WCBE_SORT_H__
#define WCBE_SORT_H__

#include <gst/gst.h>
#include <wcbe_config.h>
#include <wcbe.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_SORT \
  (wcbe_sort_get_type())
#define WCBE_SORT(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_SORT,WcbeSort))
#define WCBE_SORT_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_SORT,WcbeSortClass))
#define WCBE_IS_SORT(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_SORT))
#define WCBE_IS_SORT_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBBE_TYPE_SORT))

typedef struct _WcbeSort      WcbeSort;
typedef struct _WcbeSortClass WcbeSortClass;

struct _WcbeSort {
    GstElement element;

    GstPad *sinkpad, *srcpad;
    GThread *timeout_thread;
    GMutex *changed_active_configs_mutex;
    GCond *changed_active_configs;
    gboolean active_configs_changed;
    GstBuffer *dummy_buffer;
    GStaticRecMutex activations_mutex;
    GList *activations;
    GArray *active_configs;
    guint64 num_orphaned_frames;
    guint64 num_lagsets;
};

struct _WcbeSortClass {
    GstElementClass parent_class;
    GQuark cfg_data;
};

extern GType wcbe_sort_get_type(void);

G_END_DECLS

#endif /* WCBE_SORT_H__ */
